#INCLUDE "diamp_wwhhb.h"
#INCLUDE "../prgs/main.h"

****************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_DIAMP_WWHHB",lcCollate)

******************************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_DIAMP_WWHHB_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_DIAMP_WWHHB_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)

***************************************************************************
DEFINE CLASS _DIAMP_WWHHB AS _pdm_PlugIn && 
   Name="_DIAMP_WWHHB"

   ID=3         && ID of Plug-in
   Type="DIAMP" && 

   DIME aCaptions(6) && Array of localized captions
   DIME aCLang(6) && Array of languages

   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         SELE (This.ALTab)
         SET ORDER TO "I01"
         llEn=.F.
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "WW HTML Help Builder")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetCSS, "CSS File")
         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC

   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in

      LOCAL loPDMs,loPDM,lii,liCount,lcHTML,llHTML,;
            lcMethod,lcRow,lcPom,liz,;
            llParameters,llRemarks,llExample,llReturns,;
            lnParameters,lnRemarks,lnExample,lnReturns,lnStart,lnEnd,;
            lsParameters,lsRemarks,lsExample,lsReturns,lsStart,lsEnd,;
            lcRemarks,lcExample,lcReturns,lcParameters,liy,lcRow,llExit,lix,lcMeta

      LOCAL ARRAY laRows(1)

      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)

      lcMethod=loPar.Ram.OBJNAME

      STORE "" TO lcRemarks,lcExample,lcReturns,lcHTML,lcParameters

      lnParameters=LEN(loSetting.Parameters)
      lnReturns=LEN(loSetting.Returns)
      lnRemarks=LEN(loSetting.Remarks)
      lnExample=LEN(loSetting.Example)
      lnStart=LEN(loSetting.Start)
      lnEnd=LEN(loSetting.End)

      lsParameters=loSetting.Parameters
      lsReturns=loSetting.Returns
      lsRemarks=loSetting.Remarks
      lsExample=loSetting.Example
      lsStart=loSetting.Start
      lsEnd=loSetting.End

      liCount=ALINES(laRows,loPar.Ram.XXDESC)
      FOR lii=1 TO liCount
          lcRow=LTRIM(laRows(lii))
          liz=AT_NonSpace(@lcRow,1) && najdi prvn znak
          liz=IIF(liz=0,1,liz)

          IF SUBST(lcRow,liz,lnStart)==lsStart OR SUBST(lcRow,liz,lnEnd)==lsEnd
             llHTML=SUBST(lcRow,liz,lnStart)==lsStart
             LOOP
          ELSE
             IF !llHTML
                LOOP
             ELSE
                IF SUBST(lcRow,liz,lnParameters)==lsParameters
                   STORE .F. TO llRemarks,llExample,llReturns
                   llParameters=.T.
                   LOOP
                ELSE
                   IF SUBST(lcRow,liz,lnRemarks)==lsRemarks
                      STORE .F. TO llParameters,llExample,llReturns
                      llRemarks=.T.
                      LOOP
                   ELSE
                      IF SUBST(lcRow,liz,lnExample)==lsExample
                         STORE .F. TO llParameters,llRemarks,llReturns
                         llExample=.T.
                         LOOP
                      ELSE
                         IF SUBST(lcRow,liz,lnReturns)==lsReturns
                            STORE .F. TO llParameters,llRemarks,llExample
                            llReturns=.T.
                            LOOP
                         ELSE
                         ENDIF
                      ENDIF
                   ENDIF
                ENDIF
             ENDIF
          ENDIF

          IF llParameters
             lcParameters=lcParameters+CRLF+lcRow
          ELSE
             IF llReturns
                lcReturns=lcReturns+CRLF+lcRow
             ELSE
                IF llRemarks
                   lcRemarks=lcRemarks+CRLF+lcRow
                ELSE
                   IF llExample
                      lcExample=lcExample+CRLF+lcRow
                   ELSE

                   ENDIF
                ENDIF
             ENDIF
          ENDIF
      NEXT

      lcHTML=lcHTML+;
             [<table class="diamp_wwhhb_body" cellpadding="3">]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(1)+[<tbody>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(3)+[<td class="diamp_wwhhb_labels">]+This.GetHTMLString(PI_HTML_Syntax)+[</td>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(3)+[<td><pre class="diamp_wwhhb_pre">o.]+lcMethod+[(]+loPar.Ram.PARAMS+[)</pre></td>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21)

      IF LEN(STRTRAN(lcReturns,CRLF,""))>0
         lcHTML=lcHTML+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<tr>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+[<td class="diamp_wwhhb_labels">]+This.GetHTMLString(PI_HTML_Return)+[</td>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+[<td>]+STRTRAN(STRTRAN(STRTRAN(SUBST(lcReturns,3),"<<","<"),">>",">"),CRLF,"<br />"+m.loPDM.aSpace(21))+;
                m.loPDM.aSpace(3)+[</td>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(STRTRAN(lcParameters,CRLF,""))>0
         lcHTML=lcHTML+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<tr>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+[<td class="diamp_wwhhb_labels">]+This.GetHTMLString(PI_HTML_Params)+[</td>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+[<td>]+STRTRAN(STRTRAN(STRTRAN(SUBST(lcParameters,3),"<<","<"),">>",">"),CRLF,"<br />"+m.loPDM.aSpace(21))+;
                m.loPDM.aSpace(3)+[</td>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(STRTRAN(lcExample,CRLF,""))>0
         lcExample=STRTRAN(STRTRAN(SUBST(lcExample,3),"<<","<"),">>",">")
         lcHTML=lcHTML+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<tr>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+[<td class="diamp_wwhhb_labels">]+This.GetHTMLString(PI_HTML_Example)+[</td>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+[<td>]+m.loPDM.aSpace(21)

         IF loSetting.SyntaxColoring=1
            lcHTML=lcHTML+loPDMs.SC_Code+'>'

            IF loPDM.SyntaxColoring=0
               lcHTML=lcHTML+StrTranHTMLString(@lcExample)
            ELSE
               =RepairSource(@lcExample)
               liCount=ALINES(laRows,lcExample)
               lcMeta=""
               FOR liy=1 TO liCount
                   lcRow=laRows(liy)
                   lix=Trim_SC(@lcRow,@paComments,"") && Odezej koment a zjisti, kde je stednk
                   lcMeta=lcMeta+STR(lix,1)

                   DO WHILE lix=1 AND liy<liCount
                      liy=liy+1
                      lcRow=laRows(liy)
                      lix=Trim_SC(@lcRow,@paComments,"") && Odezej koment a zjisti, kde je stednk
                      lcMeta=lcMeta+STR(lix,1)
                   ENDDO

                   IF lix=2 && Pokud je tam stednk za komentem
                      * Pak tento koment nati
                      llExit=.F.
                      DO WHILE liy<liCount AND !llExit
                         liy=liy+1
                         llExit=AT(";",laRows(liy))=0
                         lcMeta=lcMeta+IIF(llExit,"0","2")
                      ENDDO
                   ENDIF
               NEXT
               lcHTML=lcHTML+loPDMs.HTML.PRGToHTML(@lcExample,loPDMs.SCRam,@lcMeta)
            ENDIF
            lcHTML=lcHTML+loPDMs.SC_Code_Close
         ELSE
            lcHTML=lcHTML+;
                   [<pre class="diamp_wwhhb_pre">]+lcExample+[</pre>]
         ENDIF
         lcHTML=lcHTML+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+[</td>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(STRTRAN(lcRemarks,CRLF,""))>0
         lcHTML=lcHTML+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<tr>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+[<td class="diamp_wwhhb_labels">]+This.GetHTMLString(PI_HTML_Remarks)+[</td>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+[<td>]+STRTRAN(STRTRAN(STRTRAN(SUBST(lcRemarks,3),"<<","<"),">>",">"),CRLF,"<br />"+m.loPDM.aSpace(21))+;
                m.loPDM.aSpace(3)+[</td>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21)
      ENDIF

      lcHTML=lcHTML+;
             m.loPDM.aSpace(1)+[</tbody>]+m.loPDM.aSpace(21)+;
             [</table>]+m.loPDM.aSpace(21)

      RETURN lcHTML
   ENDPROC

   PROCEDURE GetSetting()
      RETURN CREATEOBJECT("_DIAMP_WWHHB_par")
   ENDPROC


   * Nate nastaven
   PROCEDURE Open(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.Parameters=GetINIString(lcSection,"PARAMETERS",loSettings.Parameters,254,@lcFile)
      loSettings.Returns=GetINIString(lcSection,"RETURNS",loSettings.Returns,254,@lcFile)
      loSettings.Remarks=GetINIString(lcSection,"REMARKS",loSettings.Remarks,254,@lcFile)
      loSettings.Example=GetINIString(lcSection,"EXAMPLE",loSettings.Example,254,@lcFile)
      loSettings.Start=GetINIString(lcSection,"START",loSettings.Start,254,@lcFile)
      loSettings.End=GetINIString(lcSection,"END",loSettings.End,254,@lcFile)
      loSettings.Topic=GetINIString(lcSection,"TOPIC",loSettings.Topic,254,@lcFile)
      loSettings.SyntaxColoring=GetINIInt(lcSection,"SYNTAXCOLORING",loSettings.SyntaxColoring,@lcFile)
      loSettings.CSS=GetINIString(lcSection,"CSS",loSettings.CSS,254,@lcFile)
      RETURN _PDM_OK
   ENDPROC

   * Ulo nastaven
   PROCEDURE Save(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"PARAMETERS",ALLT(loSettings.Parameters),@lcFile)
      =WriteINIString(lcSection,"RETURNS",ALLT(loSettings.Returns),@lcFile)
      =WriteINIString(lcSection,"REMARKS",ALLT(loSettings.Remarks),@lcFile)
      =WriteINIString(lcSection,"EXAMPLE",ALLT(loSettings.Example),@lcFile)
      =WriteINIString(lcSection,"START",ALLT(loSettings.Start),@lcFile)
      =WriteINIString(lcSection,"END",ALLT(loSettings.End),@lcFile)
      =WriteINIString(lcSection,"TOPIC",ALLT(loSettings.Topic),@lcFile)
      =WriteINIString(lcSection,"SYNTAXCOLORING",IIF(loSettings.SyntaxColoring=1,"1","0"),@lcFile)
      =WriteINIString(lcSection,"CSS",ALLT(loSettings.CSS),@lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst)
      * loSrc - Source object
      * loDst - Destination object

      loDst.Parameters=loSrc.Parameters
      loDst.Returns=loSrc.Returns
      loDst.Remarks=loSrc.Remarks
      loDst.Example=loSrc.Example
      loDst.Topic=loSrc.Topic
      loDst.Start=loSrc.Start
      loDst.End=loSrc.End
      loDst.SyntaxColoring=loSrc.SyntaxColoring

      loDst.CSS=loSrc.CSS
   ENDPROC

   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      LOCAL loPDMs,lcLang,lcPath,lcFile,llEn
      loPDMs=EVAL(This.PDMs)
      lcLang=loPDMs.HTMLCLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Open table with HTML's string
      IF !USED(This.AHTML)
         llEn=.T.
         IF !lcLang=="en" AND ;
            loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\HTML_"+lcLang+".dbf",This.AHTML,"NOUPDATE")=0
            SELE (This.AHTML)
            SET ORDER TO "I01"
            llEn=.F.
         ENDIF
         
         IF llEn
            CREATE CURSOR (This.AHTML) (XX000 I, XX001 M)
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Return, "Return:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Remarks, "Remarks:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Example, "Example:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Syntax, "Syntax:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Params, "Parameters:")
            SELE (This.AHTML)
            INDEX ON XX000 TAG I01
         ENDIF
      ENDIF
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources()
      RETURN .T.
   ENDPROC

ENDDEFINE

**********************************************************
DEFINE CLASS _DIAMP_WWHHB_par AS custom
   Name="_DIAMP_WWHHB_par"
   OK=.F.
 
   Parameters="*:Parameters:"
   Returns="*:Returns:"
   Remarks="*:Remarks:"
   Example="*:Example:"
   Topic="*:Topic:"

   Start="*:Help Documentation"
   End="*:EndHelp"

   SyntaxColoring=0

   CSS="diamp_wwhhb.css" && Relative to diamp_vfp.fxp

   _CSS="" && Relative to ....
   _JS="" && 

ENDDEFINE

